<template>
    <div class="div">
        <div class="content-header">
            <h1>
                {{ trans(`products.title.${productTitle}`) }}
            </h1>
            <el-breadcrumb separator="/">
                <el-breadcrumb-item>
                    <a href="/backend">Home</a>
                </el-breadcrumb-item>
                <el-breadcrumb-item :to="{name: 'admin.product.product.index'}">{{ trans('products.title.products') }}
                </el-breadcrumb-item>
                <el-breadcrumb-item :to="{name: 'admin.product.product.create'}">{{ trans(`products.title.${productTitle}`) }}
                </el-breadcrumb-item>
            </el-breadcrumb>
        </div>

        <el-form ref="form" :model="product" label-width="120px" label-position="top"
                 v-loading.body="loading"
                 @keydown="form.errors.clear($event.target.name);">
            <div class="row">
                <div class="col-md-12">
                    <div class="box box-primary">
                        <div class="box-body">
                            <el-form-item label="Name"
                                          :class="{'el-form-item is-error': form.errors.has('name') }" required>
                                <el-input v-model="product.name"></el-input>
                                <div class="el-form-item__error" v-if="form.errors.has('name')"
                                     v-text="form.errors.first('name')"></div>
                            </el-form-item>
                            <el-form-item label="Price"
                                          :class="{'el-form-item is-error': form.errors.has('price') }" required>
                                <el-input v-model="product.price"></el-input>
                                <div class="el-form-item__error" v-if="form.errors.has('price')"
                                     v-text="form.errors.first('price')"></div>
                            </el-form-item>
                            <el-form-item label="Description"
                                          :class="{'el-form-item is-error': form.errors.has('description') }">
                                <ckeditor :editor="editor" v-model="product.description"></ckeditor>
                                <div class="el-form-item__error" v-if="form.errors.has('description')"
                                     v-text="form.errors.first('description')"></div>
                            </el-form-item>
                            <el-form-item >
                                <single-media zone="image" @singleFileSelected="selectSingleFile($event, 'product')"
                                    entity="Modules\Product\Entities\Product" :entity-id="$route.params.productId">
                                </single-media>
                            </el-form-item>

                            <el-form-item >
                                <el-button type="primary" @click="onSubmit()" :loading="loading">
                                    {{ trans('core.save') }}
                                </el-button>
                                <el-button @click="onCancel()">{{ trans('core.button.cancel') }}
                                </el-button>
                            </el-form-item>

                        </div>
                    </div>
                </div>
            </div>
        </el-form>
        <button v-shortkey="['b']" @shortkey="pushRoute({name: 'admin.product.product.index'})" v-show="false"></button>
    </div>
</template>

<script>
    import axios from 'axios';
    import Form from 'form-backend-validation';
    import Slugify from '../../../../Core/Assets/js/mixins/Slugify';
    import ShortcutHelper from '../../../../Core/Assets/js/mixins/ShortcutHelper';
    import ActiveEditor from '../../../../Core/Assets/js/mixins/ActiveEditor';
    import SingleFileSelector from '../../../../Media/Assets/js/mixins/SingleFileSelector';
    import ClassicEditor from '@ckeditor/ckeditor5-build-classic';

    export default {
        mixins: [Slugify, ShortcutHelper, ActiveEditor, SingleFileSelector],
        props: {
            locales: { default: null },
            productTitle: { default: null, String },
        },
        data() {
            return {
                product:{
                    name: '',
                    price: '',
                    description: ''
                },
                form: new Form(),
                loading: false,
                editor: ClassicEditor,
            };
        },
        methods: {
            onSubmit() {
                this.form = new Form(this.product);
                this.loading = true;

                this.form.post(this.getRoute())
                    .then((response) => {
                        this.loading = false;
                        this.$message({
                            type: 'success',
                            message: response.message,
                        });
                        this.$router.push({ name: 'admin.product.product.index' });
                    })
                    .catch((error) => {
                        this.loading = false;
                        this.$notify.error({
                            title: 'Error',
                            message: 'There are some errors in the form.',
                        });
                    });
            },
            onCancel() {
                this.$router.push({ name: 'admin.product.product.index' });
            },
            fetchProduct() {
                this.loading = true;
                axios.post(route('api.product.product.find', { product: this.$route.params.productId }))
                    .then((response) => {
                        this.loading = false;
                        this.product = response.data.data;
                    });
            },
            getRoute() {
                if (this.$route.params.productId !== undefined) {
                    return route('api.product.product.update', { product: this.$route.params.productId });
                }
                return route('api.product.product.store');
            },
        },
        mounted() {

            if (this.$route.params.productId !== undefined) {
                this.fetchProduct();
            }
        },
    };
</script>
